%define anolis_release 1
%bcond_with tests

Name:           python-virtualenv
Version:        20.28.0
Release:        %{anolis_release}%{?dist}
Summary:        Tool to create isolated Python environments

License:        MIT
URL:            http://pypi.python.org/pypi/virtualenv
Source0:        %{pypi_source virtualenv}

# Add /usr/share/python-wheels to extra_search_dir
Patch1:         rpm-wheels.patch

BuildArch:      noarch

BuildRequires:  python3-devel
BuildRequires:  python3-distlib
BuildRequires:  python3-filelock
BuildRequires:  python3-platformdirs
BuildRequires:  python3-hatch-vcs
BuildRequires:  python3-hatchling

%if %{with tests}
BuildRequires:  fish
BuildRequires:  tcsh
BuildRequires:  gcc
BuildRequires:  python3-flaky
BuildRequires:  python3-packaging
BuildRequires:  python3-pytest
BuildRequires:  python3-pytest-mock
BuildRequires:  python3-pytest-randomly
BuildRequires:  python3-pytest-timeout
%endif

# RPM installed wheels
BuildRequires:  python-pip-wheel
BuildRequires:  python-setuptools-wheel
BuildRequires:  python-wheel-wheel

%description
virtualenv is a tool to create isolated Python environments. virtualenv
is a successor to workingenv, and an extension of virtual-python. It is
written by Ian Bicking, and sponsored by the Open Planning Project. It is
licensed under an MIT-style permissive license.


%package -n     python3-virtualenv
Summary:        Tool to create isolated Python environments

# This virtualenv requires the "venv" install scheme on Pythons
# where we patch "posix_prefix".
# Explicitly conflict with Pythons where we don't have it yet.
Conflicts:      python3.10 < 3.10.0-3
Obsoletes:      python3-virtualenv-python26 < 16.6

# Provide "virtualenv" for convenience
Provides:       virtualenv = %{version}-%{release}

# RPM installed wheels
Requires:       python-pip-wheel
Requires:       python-setuptools-wheel
Requires:       python-wheel-wheel

%description -n python3-virtualenv
virtualenv is a tool to create isolated Python environments. virtualenv
is a successor to workingenv, and an extension of virtual-python. It is
written by Ian Bicking, and sponsored by the Open Planning Project. It is
licensed under an MIT-style permissive license

%package -n     python3-virtualenv-doc
Summary:        Documentation for python virtualenv
Requires:       python3-virtualenv = %{version}-%{release}

%description -n python3-virtualenv-doc
Documentation for python virtualenv.

%prep
%autosetup -p1 -n virtualenv-%{version}

# Remove the wheels provided by RPM packages
rm src/virtualenv/seed/wheels/embed/pip-*
rm src/virtualenv/seed/wheels/embed/setuptools-*
rm src/virtualenv/seed/wheels/embed/wheel-*

test ! -f src/virtualenv/seed/embed/wheels/*.whl

# Replace hardcoded path from rpm-wheels.patch by %%{python_wheel_dir}
sed -i "s|/usr/share/python-wheels|%{python_wheel_dir}|" src/virtualenv/util/path/_system_wheels.py
# python-hatchling (version 1.21.0) does not support the Python 3.13 classifier
sed -i '/Programming Language :: Python :: 3.13/d' pyproject.toml

%generate_buildrequires
%pyproject_buildrequires


%build
# Build code
%pyproject_wheel

%install
%pyproject_install

%if %{with tests}
%check
# Skip tests which requires internet or some extra dependencies
# Requires internet:
# - test_download_*
# Uses disabled functionalities around bundled wheels:
# - test_wheel_*
# - test_seed_link_via_app_data
# - test_base_bootstrap_via_pip_invoke
# - test_acquire.py (whole file)
# - test_bundle.py (whole file)
# Uses disabled functionalities around automatic updates:
# - test_periodic_update.py (whole file)
# Requires Python 2:
# - test_py_pyc_missing
PIP_CERT=/etc/pki/tls/certs/ca-bundle.crt \
%pytest -vv -k "not test_bundle and \
                not test_acquire and \
                not test_periodic_update and \
                not test_wheel_ and \
                not test_download_ and \
                not test_base_bootstrap_via_pip_invoke and \
                not test_seed_link_via_app_data and \
                not test_py_pyc_missing"

%endif

%files -n python3-virtualenv
%license LICENSE
%{_bindir}/virtualenv
%{python3_sitelib}/virtualenv/
%{python3_sitelib}/virtualenv-%{version}.dist-info/

%files -n python3-virtualenv-doc
%doc README.md

%changelog
* Tue Jun 17 2025 yangcheng <yc02267530@alibaba-inc.com> - 20.28.0-1
- update to 20.28.0 to fix CVE-2024-53899

* Wed Mar 13 2024 Zhao Hang <wb-zh951434@alibaba-inc.com> - 20.21.0-3
- Rebuild with python3.11

* Sat Mar 25 2023 happy_orange <songnannan@linux.alibaba.com> - 20.21.0-2
- rebuild to fix version error

* Fri Mar 17 2023 happy_orange <songnannan@linux.alibaba.com> - 20.21.0-1
- update to 20.21.0

* Wed Feb 01 2023 mgb01105731 <mgb01105731@alibaba-inc.com> - 20.17.0-1
- update to version 20.17.0

* Tue Jan 03 2023 mgb01105731 <mgb01105731@alibaba-inc.com> - 20.16.7-1
- update to version 20.16.7

* Thu Oct 13 2022 happy_orange <songnannan@linux.alibaba.com> - 20.16.5-3
- change the python dist for sysom

* Thu Oct 13 2022 happy_orange <songnannan@linux.alibaba.com> - 20.16.5-2
- add virtualenv-3 binary for sysom

* Thu Oct 13 2022 happy_orange <songnannan@linux.alibaba.com> - 20.16.5-1
- Init pacakge from upstream
